<template>
  <section class="flex justify-between align-center flex-wrap px-4 py-2 lg:py-6 bg-white shadow z-10">
    <h1 class="flex items-center">
      <span class="flex justify-center items-center w-8 h-8 lg:w-10 lg:h-10 mr-2 bg-gradient-to-l from-teal-400 to-cyan-500 text-white rounded-lg">
        <v-icon
          :icon="$router.currentRoute.value.meta.icon as string"
          class="text-[1.5rem] lg:text-[1.75rem]"
        />
      </span>

      <span class="text-2xl lg:text-3xl font-light">
        {{ $router.currentRoute.value.meta.title }}
      </span>
    </h1>

    <div class="block lg:hidden">
      <v-btn
        icon="mdi-menu"
        variant="text"
        @click="isDrawerShown = true"
      />
    </div>

    <div class="flex items-center gap-2 justify-start lg:justify-end flex-auto w-full lg:w-auto pt-2 lg:pt-0">
      <v-text-field
        v-if="showSearch"
        :clearable="!loading"
        rounded
        flat
        variant="solo-filled"
        class="flex-auto lg:flex-initial lg:min-w-[20rem]"
        prepend-inner-icon="mdi-magnify"
        placeholder="Поиск"
        type="input"
        hide-details
        density="compact"
        @input="onSearchInput"
        @click:clear="emit('search', '')"
      >
        <template #append-inner>
          <v-btn
            v-tooltip:left="{ text: `Минимум символов: ${MIN_SEARCH_TERM_LENGTH}`, openOnClick: true }"
            icon="mdi-shield-alert-outline"
            variant="plain"
            size="small"
            :ripple="false"
          />
        </template>
      </v-text-field>

      <v-btn
        rounded
        variant="tonal"
        :loading="loading"
        class="text-cyan-700"
        @click="emit('refresh')"
      >
        Обновить
      </v-btn>
    </div>
  </section>

  <section
    class="flex flex-col absolute z-50 bg-white w-full h-full translate-x-full transition-all duration-300 bg-gradient-to-br from-teal-600 to-cyan-800 text-white"
    :class="{ '!translate-x-0': isDrawerShown }"
  >
    <section class="flex items-center justify-between px-4 py-2">
      <section class="flex items-center text-xl font-black tracking-wider uppercase leading-none">
        <v-icon
          icon="mdi-home"
          class="mr-2 text-2xl"
        />

        <span class="select-none">{{ inject('appName') }}</span>
      </section>

      <v-btn
        icon="mdi-close"
        variant="text"
        @click="isDrawerShown = false"
      />
    </section>

    <v-divider thickness="2" />

    <nav class="flex-auto">
      <NavMenu :markers="false" />
    </nav>

    <v-divider thickness="2" />

    <section class="p-4 flex items-center">
      <ActiveAccount />
    </section>
  </section>
</template>

<script setup lang="ts">
import { inject, ref } from 'vue';

import { MIN_SEARCH_TERM_LENGTH } from '@/declarations';
import { debounce } from '@/utils';
import NavMenu from '@/components/content/NavMenu.vue';
import ActiveAccount from '@/components/content/ActiveAccount.vue';

type PageHeaderProps = {
  showSearch?: boolean;
  loading?: boolean;
}

const emit = defineEmits(['search', 'refresh']);
withDefaults(defineProps<PageHeaderProps>(), {
  showSearch: false,
  loading: false,
});

const isDrawerShown = ref(false);

const onSearchInput = debounce(500, (event: InputEvent) => {
  const target = event.target as HTMLInputElement;
  const value = target.value;

  const currentTerm = value?.trim() ?? '';

  if (!currentTerm) {
    return emit('search', currentTerm);
  }

  if (currentTerm.length < MIN_SEARCH_TERM_LENGTH) {
    return;
  }

  emit('search', currentTerm);
});
</script>